## ncid-0.83-src.tar.gz

=== Makefile ===
# This Makefile requires either GNU make or BSD make

###########################################################################
# make local             - builds for /usr/local and /var                 #
# make install           - installs files in /usr/local and /var          #
#                                                                         #
# make package           - builds for /usr, /etc, and /var                #
# make package-install   - installs files in /usr, /etc, and /var         #
#                                                                         #
# make fedora            - builds for Fedora (includes init.d/ files)     #
# make fedora-install    - installs in /usr, /etc, and /var               #
#                                                                         #
# make ubuntu            - builds for Ubuntu (includes init.d/ files)     #
# make ubuntu-install    - installs in /usr, /etc, and /var               #
#                                                                         #
# make mandir            - builds man text and html files                 #
#                          (no install for the *.txt and *.html files)    #
#                                                                         #
# make tivo-mips         - builds for a mips TiVo in /usr/local or prefix #
#                          can also prefix and prefix[234]                #
# make tivo-install      - installs in /usr/local                         #
#                          can also prefix and prefix[234]                #
# make tivo-s1           - builds for a ppc TiVo for /var/hack            #
# make tivo-s2           - builds for a mips TiVo for /var/hack           #
# make tivo-hack-install - basic install into /var/hack                   #
#                          uses the cross compilers at:                   #
#                          http://tivoutils.sourceforge.net/              #
#                          usr.local.powerpc-tivo.tar.bz2                 #
#                          (x86 cross compiler for Series1)               #
#                          usr.local.mips-tivo.tar.bz2                    #
#                          (x86 cross compiler for Series2)               #
#                                                                         #
# make freebsd           - builds for FreeBSD in /usr/local               #
# make freebsd-install   - installs in /usr/local                         #
#                                                                         #
# make mac               - builds for Macintosh OS X in /usr/local        #
# make mac-fat           - builds universal OS X binaries in /usr/local   #
# make mac-install       - installs in /usr/local                         #
#                                                                         #
# make cygwin            - builds for Windows using cygwin                #
#                          (does not function with modem or comm port)    #
# make cygwin-install    - installs files in /usr/local, and /var         #
###########################################################################

subdirs      = server client cidgate modules scripts tools man test \
               debian Fedora FreeBSD TiVo

Version := $(shell sed 's/.* //; 1q' VERSION)

# the prefix must end in a - (if part of a name) or a / (if part of a path)
MIPSXCOMPILE = mips-TiVo-linux-
PPCXCOMPILE  = /usr/local/tivo/bin/

# prefix and prefix2 are used on a make, install, and making a package
# prefix3 is used on install to make a package
prefix       = /usr/local
prefix2      = $(prefix)
prefix3      =

settag       = NONE
setlock      = NONE
setname      = NONE
setmod       = NONE

BIN          = $(prefix)/bin
SBIN         = $(prefix)/sbin
SHARE        = $(prefix)/share
ETC          = $(prefix2)/etc
DEV          = $(prefix3)/dev
VAR          = $(prefix3)/var

CONFDIR      = $(ETC)/ncid
MODULEDIR    = $(SHARE)/ncid
IMAGEDIR	 = $(SHARE)/pixmaps/ncid
MAN          = $(SHARE)/man
LOG          = $(VAR)/log
RUN          = $(VAR)/run

CONF         = $(CONFDIR)/ncidd.conf
ALIAS        = $(CONFDIR)/ncidd.alias
MODEMDEV     = $(DEV)/modem
CALLLOG      = $(LOG)/cidcall.log
DATALOG      = $(LOG)/ciddata.log
LOGFILE      = $(LOG)/ncidd.log
PIDFILE      = $(RUN)/ncidd.pid

WISH         = wish
TCLSH        = tclsh

# local additions to CFLAGS
MFLAGS  = -W -Wmissing-declarations \

default:
	@echo "make requires an argument, see top of Makefile for description:"
	@echo
	@echo "    make local              # builds for /usr/local and /var"
	@echo "    make install            # installs into /usr/local and /var"
	@echo "    make package            # builds for /usr and /var"
	@echo "    make package-install    # installs into for /usr and /var"
	@echo "    make fedora             # builds for Fedora, includes init.d/"
	@echo "    make fedora-install     # installs in /usr, /etc, and /var"
	@echo "    make ubuntu             # builds for Ubuntu, includes init.d/"
	@echo "    make ubuntu-install     # installs in /usr, /etc, and /var"
	@echo "    make tivo-mips          # builds for TiVo in /usr/local, /var"
	@echo "    make tivo-install       # installs in /usr/local, /var"
	@echo "    make tivo-s1            # builds for a series1 in /var/hack"
	@echo "    make tivo-s2            # builds for a series[23] in /var/hack"
	@echo "    make tivo-hack-install  # installs in /var/hack, /var"
	@echo "    make freebsd            # builds for FreeBSD in /usr/local, /var"
	@echo "    make freebsd-install    # installs in /usr/local, /var"
	@echo "    make mac                # builds for Mac in /usr/local, /var"
	@echo "    make mac-fat            # builds for Mac in /usr/local, /var"
	@echo "    make mac-install        # installs in /usr/local, /var"
	@echo "    make cygwin             # builds for windows using Cygwin"
	@echo "    make cygwin-install     # installs in /usr/local"

local: serverdir clientdir moduledir cidgatedir tooldir scriptsdir

version.h: version.h-in
	sed "s/XXX/$(Version)/" $? > $@

fedoradir:
	cd Fedora; $(MAKE) init prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3)

freebsddir:
	cd FreeBSD; $(MAKE) rcd prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3)

ubuntudir:
	cd debian; $(MAKE) init prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3)

tivodir:
	cd TiVo; $(MAKE) prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3) \
                     OSDCLIENT=$(OSDCLIENT)

moduledir:
	cd modules; $(MAKE) modules prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3)

cidgatedir:
	cd cidgate; $(MAKE) cidgate prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3) BIN=$(BIN) SBIN=$(SBIN) \
                      MFLAGS="$(MFLAGS)" STRIP=$(STRIP)

serverdir:
	cd server; $(MAKE) server prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3) BIN=$(BIN) SBIN=$(SBIN) \
                      MFLAGS="$(MFLAGS)" STRIP=$(STRIP)

clientdir:
	cd client; $(MAKE) client prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3) BIN=$(BIN) SBIN=$(SBIN) \
                      MFLAGS="$(MFLAGS)" STRIP=$(STRIP)

tooldir:
	cd tools; $(MAKE) tools prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3) BIN=$(BIN)

scriptsdir:
	cd scripts; $(MAKE) scripts prefix=$(prefix) prefix2=$(prefix2) \
                      prefix3=$(prefix3)

mandir:
	cd man; $(MAKE) all prefix=$(prefix) prefix2=$(prefix2) MAN=$(MAN)

package:
	$(MAKE) local prefix=/usr prefix2=

package-install:
	$(MAKE) install prefix=/usr prefix2=

fedora:
	$(MAKE) local fedoradir prefix=/usr prefix2= \
            LOCKFILE=/var/lock/lockdev/LCK..

fedora-install:
	$(MAKE) install install-fedora prefix=/usr prefix2=

ubuntu:
	$(MAKE) local ubuntudir prefix=/usr prefix2= \
            LOCKFILE=/var/lock/LCK..

ubuntu-install:
	$(MAKE) install install-ubuntu prefix=/usr prefix2=

tivo-s1:
	$(MAKE) tivo-ppc mandir prefix=/var/hack

tivo-ppc:
	$(MAKE) local tivodir \
			CC=$(PPCXCOMPILE)gcc \
			MFLAGS="-DTIVO_S1 -D__need_timeval" \
			LD=$(PPCXCOMPILE)ld \
			RANLIB=$(PPCXCOMPILE)ranlib \
			setname="TiVo requires CLOCAL" \
			settag="TiVo PPC Modem Port" \
			setlock="TiVo Modem Lockfile" \
			setmod="out2osd" OSDCLIENT=tivocid

tivo-s2:
	$(MAKE) tivo-mips mandir prefix=/var/hack

tivo-hack-install:
	$(MAKE) install-server install-client \
            install-modules install-cidgate install-tivo \
            prefix=/var/hack prefix2=$(prefix) prefix3= setmod=tivo

tivo-mips:
	$(MAKE) local tivodir fedoradir \
			CC=$(MIPSXCOMPILE)gcc \
			MFLAGS="-std=gnu99" \
			LD=$(MIPSXCOMPILE)ld \
			RANLIB=$(MIPSXCOMPILE)ranlib \
			setname="TiVo requires CLOCAL" \
			settag="TiVo MIPS Modem Port" \
			setlock="TiVo Modem Lockfile" \
			setmod="ncid-tivo" OSDCLIENT=tivoncid

tivo-install:
	$(MAKE) install-server install-client install-modules install-cidgate \
              install-man install-scripts install-fedora setmod=tivo

freebsd:
	$(MAKE) local freebsddir prefix=/usr/local prefix2=$(prefix) \
            LOCKFILE=/var/spool/lock/LCK.. \
            WISH=/usr/local/bin/wish*.* TCLSH=/usr/local/bin/tclsh*.* \
            BASH=/usr/local/bin/bash

freebsd-install:
	$(MAKE) install MAN=$(prefix)/man
	cd FreeBSD; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3) \
            MAN=$(prefix)/man

mac-fat:
	$(MAKE) local settag="Macintosh OS X" \
            LOCKFILE=/var/spool/uucp/LCK.. \
            MFLAGS="-mmacosx-version-min=10.3.9 -arch ppc" STRIP=
	mv server/ncidd server/ncidd.ppc-mac
	mv cidgate/sip2ncid cidgate/sip2ncid.ppc-mac
	mv cidgate/ncid2ncid cidgate/ncid2ncid.ppc-mac
	$(MAKE) clean
	$(MAKE) local settag="Macintosh OS X" \
            LOCKFILE=/var/spool/uucp/LCK.. \
            MFLAGS="-mmacosx-version-min=10.4 -arch i386" STRIP=
	mv server/ncidd server/ncidd.i386-mac
	mv cidgate/sip2ncid cidgate/sip2ncid.i386-mac
	mv cidgate/ncid2ncid cidgate/ncid2ncid.i386-mac
	lipo -create server/ncidd.ppc-mac server/ncidd.i386-mac \
         -output server/ncidd
	lipo -create cidgate/sip2ncid.ppc-mac cidgate/sip2ncid.i386-mac \
         -output cidgate/sip2ncid
	lipo -create cidgate/ncid2ncid.ppc-mac cidgate/ncid2ncid.i386-mac \
         -output cidgate/ncid2ncid

mac:
	$(MAKE) local settag="Macintosh OS X" \
            LOCKFILE=/var/spool/uucp/LCK.. \
            MFLAGS="-mmacosx-version-min=10.4" STRIP=

mac-install:
	$(MAKE) install MAN=$(prefix)/man

cygwin:
	$(MAKE) local \
            MFLAGS=-IC:/WpdPack/Include \
            LDLIBS="-s -LC:/WpdPack/Lib -lwpcap" \
            SBIN=$(prefix)/bin \
            settag="set noserial" \
            MODEMDEV=$(DEV)/com1

cygwin-install:
	$(MAKE) install \
            SBIN=$(prefix)/bin \
            settag="set noserial" \
            MODEMDEV=$(DEV)/com1

install: install-server install-client install-man \
         install-modules install-cidgate install-scripts install-tools

install-fedora:
	cd Fedora; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3)

install-ubuntu:
	cd debian; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3)

install-tivo:
	cd TiVo; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3)

install-cidgate:
	cd cidgate; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3)

install-modules:
	cd modules; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3) \
			setmod=$(setmod)

install-scripts:
	cd scripts; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3)

install-tools:
	cd tools; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3) ALIAS=$(ALIAS)

install-man:
	cd man; \
	$(MAKE) install prefix=$(prefix) prefix2=$(prefix2) prefix3=$(prefix3) MAN=$(MAN)

install-server:
	cd server; \

=== Fedora/Makefile ===
INIT        = ncidd.init ncidsip.init ncid2ncid.init \
              sip2ncid.init yac2ncid.init ncid-mythtv.init ncid-page.init \
              ncid-samba.init ncid-speak.init ncid-yac.init \
              ncid-initmodem.init
SPEC        = ncid.spec
FILES		= README.Fedora Makefile $(INIT) $(SPEC)

Version := $(shell sed 's/.* //; 1q' ../VERSION)

prefix		= /usr/local
prefix2		= $(prefix)
prefix3     =
prefix4     =

#SHARP      = ;/\# Source networking/,/NETWORKING.*exit/{N;d}

BIN			= $(prefix)/bin
SBIN		= $(prefix)/sbin
ETC			= $(prefix2)/etc
VAR         = $(prefix3)/VAR
FUN         = $(prefix4)/etc/rc.d/init.d/functions

RCDIR       = $(ETC)/rc.d
INITDIR     = $(RCDIR)/init.d
CONFDIR		= $(ETC)/ncid
LOG			= $(VAR)/log

PLSCRIPT    = $(PLSOURCE:.pl=)
SHSCRIPT    = $(SHSOURCE:.sh=)
SITE        = $(INIT:.init=)

init: $(SITE)

install: $(SITE) dirs
	install -m 755 $(SITE) $(INITDIR)

dirs:
	@if ! test -d $(INITDIR); then mkdir -p $(INITDIR); fi

clean:

clobber: clean
	rm -f $(SITE)
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: .init -in

.init : *.init
	sed '/exec/s,/usr/local,$(prefix),;/config/s,/usr/local,$(prefix2),;s,.*/functions,. $(FUN),$(SHARP)' $< > $@
	chmod +x $@

-in : *-in
	sed 's,X.XX,$(Version),' $< > $@

=== FreeBSD/Makefile ===
RCF     = ncidd.rc ncidsip.rc ncid2ncid.rc sip2ncid.rc \
          yac2ncid.rc ncid-mythtv.rc ncid-page.rc ncid-samba.rc \
          ncid-speak.rc ncid-yac.rc ncid-initmodem.rc
FILES   = README.FreeBSD Makefile $(RCF)

prefix  = /usr/local
prefix2 = $(prefix)

ETC     = $(prefix2)/etc
RCD     = $(ETC)/rc.d
CONFDIR = $(ETC)/ncid

SITE    = $(RCF:.rc=)

rcd: $(SITE)

install: install-rcd

install-rcd: $(RCF)
	@if test ! -d $(RCD); then mkdir -p $(RCD); fi
	install -m 755 $(SITE) $(RCD)

clean:

clobber: clean
	rm -f $(SITE)
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

files: $(FILES)

.SUFFIXES: .rc

.rc : *.rc
	sed '/ConfigDir/s,/usr/local/etc/ncid,$(CONFDIR),' $< > $@
	chmod +x $@

=== TiVo/Makefile ===
SHSOURCE    = startncid.sh initmodem.sh
SYMLINKS    = tivocid tivoncid
ETCFILE     =
FILES       = Makefile $(SHSOURCE) $(MANSRC)
DIST        =

prefix      = /usr/local
prefix2     = $(prefix)
prefix3     =

BIN         = $(prefix)/bin
SBIN        = $(prefix)/sbin
SHARE       = $(prefix)/share
ETC         = $(prefix2)/etc
VAR         = $(prefix3)/var

INIT        = $(ETC)/rc.d/init.d
CONFDIR     = $(ETC)/ncid
LOG         = $(VAR)/log
MAN         = $(SHARE)/man

CONF        = $(CONFDIR)/ncidd.conf
ALIAS       = $(CONFDIR)/ncidd.alias
CALLLOG     = $(LOG)/cidcall.log
DATALOG     = $(LOG)/ciddata.log
MAN1        = $(MAN)/man1

PLSCRIPT    = $(PLSOURCE:.pl=)
SHSCRIPT    = $(SHSOURCE:.sh=)
SITE        = $(DIST:-in=)

OSDCLIENT   = tivoncid

tivo: $(SHSCRIPT) $(SITE) $(SYMLINKS)

$(SYMLINKS):
	touch ncid
	ln -s ncid $@

install: install-script

install-script: $(SHSCRIPT)
	install -m 755 $(SHSCRIPT) $(BIN)
	install -m 755 $(SYMLINKS) $(BIN)

clean:

clobber: clean
	rm -f $(SHSCRIPT) $(SITE) $(SYMLINKS) ncid
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: .sh

.sh : *.sh
	sed '/OSDCLIENT/s,^OSDCLIENT=tivo,\#OSDCLIENT=tivo,;s,^\#OSDCLIENT=$(OSDCLIENT),OSDCLIENT=$(OSDCLIENT),' $< > $@
	chmod 755 $@

=== cidgate/Makefile ===
PROG1       = sip2ncid
PROG2       = ncid2ncid
PROG        = $(PROG1) $(PROG2)
SRC1        = $(PROG1).c config.c
SRC2        = $(PROG2).c
SRC         = $(SRC1) $(SRC2)
CONF        = $(PROG1).conf ncidsip.conf yac2ncid.conf \
              ncid2ncid.conf ncid2ncid.conf
HEADER1     = $(PROG1).h config.h
HEADER2     = $(PROG2).h
HEADER      = $(HEADER1) $(HEADER2)
SOURCE      = $(SRC) $(CONF) $(HEADER)
PLSOURCE    = ncidsip.pl
SHSOURCE    = yac2ncid.sh
FILES       = README.gateways Makefile $(SOURCE ) $(PLSOURCE) $(SHSOURCE)

Version := $(shell sed 's/.* //; 1q' ../VERSION)

# the prefix must end in a - (if part of a name) or a / (if part of a path)
MIPSXCOMPILE = mips-TiVo-linux-
PPCXCOMPILE  = /usr/local/tivo/bin/

prefix      = /usr/local
prefix2     = $(prefix)
prefix3     =

BASH=/bin/bash

BIN         = $(prefix)/bin
SBIN        = $(prefix)/sbin
ETC         = $(prefix2)/etc
VAR         = $(prefix3)/var

CONFDIR     = $(ETC)/ncid
CONFFILE1   = $(CONFDIR)/$(PROG1).conf
CONFFILE2   = $(CONFDIR)/$(PROG2).conf

LOGDIR      = $(VAR)/log
RUNDIR      = $(VAR)/run
PIDFILE1    = $(RUNDIR)/$(PROG1).pid
PIDFILE2     = $(RUNDIR)/$(PROG2).pid

OBJECT1     = $(SRC1:.c=.o)
OBJECT2     = $(SRC2:.c=.o)

DEFINE1     = -D_BSD_SOURCE \
              -DCONFIG=\"$(CONFFILE1)\" \
              -DPIDFILE=\"$(PIDFILE1)\"

DEFINE2     = -DCONFIG=\"$(CONFFILE2)\" \
              -DPIDFILE=\"$(PIDFILE2)\"

MFLAGS      = -W -Wmissing-declarations

CFLAGS      = -O2 -I. -I.. $(MFLAGS)

STRIP       = -s
LDFLAGS     = $(STRIP)
LDLIBS      = -lpcap

PLSCRIPT    = $(PLSOURCE:.pl=)
SHSCRIPT    = $(SHSOURCE:.sh=)

usage:
	@echo "to build a TiVo ppc binary for /var/hack: make tivo-s1"
	@echo "to build a TiVo mips binary for /var/hack: make tivo-s2"
	@echo "to build a TiVo mips binary for /usr/local: make tivo-mips"
	@echo "to build a Win/cygwin binary: make cygwin"
	@echo "to build a Linux, BSD, or Mac binary: make local"
	@echo "to install in /usr/local: make install"

tivo-s1:
	$(MAKE) cidgate prefix=/var/hack \
			CC="$(PPCXCOMPILE)gcc" \
			LD="$(PPCXCOMPILE)LD" \
			MFLAGS= \
			CFLAGS="$(CFLAGS) -DTIVO_S1"
			

tivo-s2:
	$(MAKE) cidgate prefix=/var/hack \
			CC="$(MIPSXCOMPILE)gcc" \
			LD="$(MIPSXCOMPILE)LD" \
			MFLAGS= \
			CFLAGS="$(CFLAGS) -D__TIVO_S2__"

tivo-mips:
	$(MAKE) cidgate \
			CC="$(MIPSXCOMPILE)gcc" \
			LD="$(MIPSXCOMPILE)LD" \
			MFLAGS= \
			CFLAGS="$(CFLAGS) -D__TIVO_S2__"

cygwin:
	$(MAKE) cidgate prefix=/usr prefix2= \
			CFLAGS="$(CFLAGS) -IC:/WpdPack/Include" \
			LDLIBS="$(LDLIBS) -LC:/WpdPack/Lib -lwpcap"

local:
	$(MAKE) cidgate

tivo: $(PROG)

$(PROG1): $(SRC1) $(HEADER1) ../version.h
	$(CC) $(DEFINE1) $(CFLAGS) -c $(SRC1)
	$(CC) -o $@ $(OBJECT1) $(CFLAGS) $(LDFLAGS) $(LDLIBS)

$(PROG2): $(SRC2) $(HEADER2) ../version.h
	$(CC) $(DEFINE2) $(CFLAGS) -c $(SRC2)
	$(CC) -o $@ $(OBJECT2) $(CFLAGS) $(LDFLAGS)

$(OBJECTS): $(HEADER)

../version.h: ../version.h-in
	sed "s/XXX/$(Version)/" $? > $@

cidgate: $(PROG) $(PLSCRIPT) $(SHSCRIPT)

install: $(PROG) dirs install-script install-etc
	install -m 755 $(PROG1) $(SBIN)
	install -m 755 $(PROG2) $(BIN)

install-script: $(PLSCRIPT) $(SHSCRIPT)
	install -m 755 $(SHSCRIPT) $(BIN)
	install -m 755 $(PLSCRIPT) $(SBIN)

install-etc: $(CONF)
	@if test -f $(CONFDIR)/$(PROG1).conf; \
		then install -m 644 $(PROG1).conf $(CONFDIR)/$(PROG1).conf.new; \
		else install -m 644 $(PROG1).conf $(CONFDIR); \
	fi
	@if test -f $(CONFDIR)/$(PROG2).conf; \
		then install -m 644 $(PROG2).conf $(CONFDIR)/$(PROG2).conf.new; \
		else install -m 644 $(PROG2).conf $(CONFDIR); \
	fi
	@if test -f $(CONFDIR)/ncidsip.conf; \
		then install -m 644 ncidsip.conf $(CONFDIR)/ncidsip.conf.new; \
		else install -m 644 ncidsip.conf $(CONFDIR); \
	fi
	@if test -f $(CONFDIR)/yac2ncid.conf; \
		then install -m 644 yac2ncid.conf $(CONFDIR)/yac2ncid.conf.new; \
		else install -m 644 yac2ncid.conf $(CONFDIR); \
	fi

dirs:
	@if ! test -d $(BIN); then mkdir -p $(BIN); fi
	@if ! test -d $(SBIN); then mkdir -p $(SBIN); fi
	@if ! test -d $(CONFDIR); then mkdir -p $(CONFDIR); fi

clean:
	rm -f *.o *.a

clobber: clean
	rm -f $(PROG) $(PLSCRIPT) $(SHSCRIPT)
	rm -f $(PROG1).ppc-mac $(PROG1).i386-mac
	rm -f $(PROG2).ppc-mac $(PROG2).i386-mac
	rm -f a.out *.log *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: .init .pl .sh

.init : *.init
	sed '/ConfigDir/s,/usr/local/etc/ncid,$(CONFDIR),' $< > $@
	chmod +x $@

.pl : *.pl
	#cp $< $@
	sed 's/XxXxX/$(Version)/' $< > $@
	chmod +x $@

.sh : *.sh
	sed '1s,/bin/bash,$(BASH),;/ConfigDir/s,/usr/local/etc/ncid,$(CONFDIR),;s/XxXxX/$(Version)/' $< > $@
	chmod +x $@

=== client/Makefile ===
SHSOURCE    = ncid.sh
LOGO        = ncid.gif
DIST        = ncid.conf-in
FILES       = README.clients Makefile $(SOURCE) $(SHSOURCE) $(LOGO) $(DIST)

Version := $(shell sed 's/.* //; 1q' ../VERSION)

prefix      = /usr/local
prefix2     = $(prefix)
prefix3     =

settag      = NONE
setlock     = NONE
setname     = NONE

BASH=/bin/bash

BIN         = $(prefix)/bin
SHARE       = $(prefix)/share
ETC         = $(prefix2)/etc

CONFDIR     = $(ETC)/ncid
CONFFILE    = $(CONFDIR)/ncid.conf

MODULEDIR   = $(SHARE)/ncid
IMAGEDIR    = $(SHARE)/pixmaps/ncid

WISH        = wish
TCLSH       = tclsh

SHSCRIPT    = $(SHSOURCE:.sh=)

SITE        = $(DIST:-in=)

usage:
	@echo "to build a TiVo ppc binary for /var/hack: make tivo-s1"
	@echo "to build a TiVo mips binary for /var/hack: make tivo-s2"
	@echo "to build a TiVo mips binary for /usr/local: make tivo-mips"
	@echo "to build a Win/cygwin binary: make cygwin"
	@echo "to build a Linux, BSD, or Mac binary: make local"
	@echo "to install in /usr/local: make install"

tivo-s1:
	$(MAKE) tivo-ppc prefix=/var/hack \

tivo-ppc:
	$(MAKE) client \
	touch tivo-ppc
			

tivo-s2:
	$(MAKE) tivo-mips prefix=/var/hack

tivo-mips:
	$(MAKE) client \
	touch tivo-mips

cygwin:
	$(MAKE) client prefix=/usr prefix2=

local:
	$(MAKE) client

../version.h: ../version.h-in
	sed "s/XXX/$(Version)/" $? > $@

client: $(SHSCRIPT) $(SITE)

install:dirs install-script install-etc

install-script: $(SHSCRIPT)
	install -m 755 $(SHSCRIPT) $(BIN)
	install -m 644 $(LOGO) $(IMAGEDIR)

install-tivo: install
	install -m 755 tivocid tivoncid $(BIN)

install-etc: $(SITE)
	@if test -f $(CONFDIR)/$(SHSCRIPT).conf; \
		then install -m 644 $(SHSCRIPT).conf $(CONFDIR)/$(SHSCRIPT).conf.new; \
		else install -m 644 $(SHSCRIPT).conf $(CONFDIR); \
	fi

dirs:
	@if ! test -d $(BIN); then mkdir -p $(BIN); fi
	@if ! test -d $(CONFDIR); then mkdir -p $(CONFDIR); fi
	@if ! test -d $(IMAGEDIR); then mkdir -p $(IMAGEDIR); fi

clean:
	rm -f *.o *.a

clobber: clean
	rm -f $(SHSCRIPT) $(SHSCRIPT).conf
	rm -f tivocid tivoncid tivo-mips tivo-ppc
	rm -f a.out *.log *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: .init .sh -in

.init : *.init
	sed '/ConfigDir/s,/usr/local/etc/ncid,$(CONFDIR),' $< > $@
	chmod +x $@

.sh : *.sh
	sed 's,/usr/local/share/ncid,$(MODULEDIR),;s,/usr/local/etc/ncid,$(CONFDIR),;s,/usr/local/share/pixmaps/ncid,$(IMAGEDIR),;s,WISH=wish,WISH=$(WISH),;s,TCLSH=tclsh,TCLSH=$(TCLSH),;s,/usr/local/bin,$(BIN),;s,XxXxX,$(Version),' $< > $@
	chmod +x $@

-in : *-in
	sed '/share/s,/usr/local,$(prefix),;/$(settag)/s/# set/set/;/$(setname)/s/# set/set/;/$(setlock)/s/# set/set/' $< > $@

=== debian/Makefile ===
DIST        = ncidd.init ncidsip.init ncid2ncid.init \
              sip2ncid.init yac2ncid.init ncid-mythtv.init ncid-page.init \
              ncid-samba.init ncid-speak.init ncid-yac.init \
              ncid-initmodem.init
FILES		= README Makefile.Debain $(DIST)

prefix		= /usr/local
prefix2		= $(prefix)
prefix3     =

BIN			= $(prefix)/bin
SBIN		= $(prefix)/sbin
ETC			= $(prefix2)/etc
VAR         = $(prefix3)/VAR

INIT        = $(ETC)/init.d
CONFDIR		= $(ETC)/ncid
LOG			= $(VAR)/log

PLSCRIPT    = $(PLSOURCE:.pl=)
SHSCRIPT    = $(SHSOURCE:.sh=)
SITE        = $(DIST:.init=)

init: $(SITE)

install: $(SITE) dirs
	install -m 755 $(SITE) $(INIT)

dirs:
	@if ! test -d $(INIT); then mkdir -p $(INIT); fi

clean:

clobber: clean
	rm -f $(SITE)
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: .init

.init : *.init
	sed '/ConfigDir/s,/usr/local/etc/ncid,$(CONFDIR),' $< > $@
	chmod +x $@

=== man/Makefile ===
MANSRC1 = ncid.1 ncidmodules.1 ncidrotate.1 \
          ncidtools.1 ncid2ncid.1 yac2ncid.1
MANSRCI = cidalias.1 cidcall.1 cidupdate.1 \
          ncid-initmodem.1 ncid-kpopup.1 ncid-page.1 \
          ncid-samba.1 ncid-speak.1 ncid-mythtv.1 \
          ncid-skel.1 ncid-yac.1
MANSRCT = ncid-tivo.1
MANSRC5 = ncidd.blacklist.5 ncid.conf.5 \
          ncidd.conf.5 ncidd.alias.5 ncidmodules.conf.5 \
          ncidrotate.conf.5 ncidsip.conf.5 ncid2ncid.conf.5 \
          sip2ncid.conf.5 yac2ncid.conf.5
MANSRC8 = ncidd.8 ncidsip.8 sip2ncid.8
MANSRC  = $(MANSRC1) $(MANSRCI) $(MANSRC5) $(MANSRC8)
FILES   = Makefile $(MANSRC)

prefix  = /usr/local
prefix2 = $(prefix)

setmod    = NONE

SHARE   = $(prefix)/share

MAN     = $(SHARE)/man
MAN1    = $(MAN)/man1
MAN5    = $(MAN)/man5
MAN8    = $(MAN)/man8

all: txt html

man:

txt: $(MANSRC1:.1=.1.txt) $(MANSRC5:.5=.5.txt) $(MANSRC8:.8=.8.txt)
	chmod 644 *.txt
	touch txt

html: $(MANSRC1:.1=.1.html) $(MANSRC5:.5=.5.html) $(MANSRC8:.8=.8.html)

install: install-man

install-man: $(MANSRC) dirs
	cd $(MAN1); rm -f $(MANSRC1) $(MANSRCI) $(MANSRCT)
	cd $(MAN5); rm -f $(MANSRC5)
	cd $(MAN8); rm -f $(MANSRC8)
	install -m 644 $(MANSRC1) $(MANSRCI) $(MAN1)
	@if [ "$(setmod)" != "NONE" ] ; then install -m 755 $(MANSRCT) $(MAN1); fi
	install -m 644 $(MANSRC5) $(MAN5)
	install -m 644 $(MANSRC8) $(MAN8)

dirs:
	@if ! test -d $(MAN1); then mkdir -p $(MAN1); fi
	@if ! test -d $(MAN5); then mkdir -p $(MAN5); fi
	@if ! test -d $(MAN8); then mkdir -p $(MAN8); fi

clean:

clobber: clean
	rm -f man txt *.man *.txt *.html
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

files: $(FILES)

.SUFFIXES: .1 .5 .8 .1.txt .5.txt .8.txt .1.html .5.html .8.html

.1.1.txt : *.1
	nroff -man $< | col -bx > $@

.5.5.txt : *.5
	nroff -man $< | col -bx > $@

.8.8.txt : *.8
	nroff -man $< | col -bx > $@

.1.1.html : *.1
	man2html $< > $@

.5.5.html : *.5
	man2html $< > $@

.8.8.html : *.8
	man2html $< > $@

=== modules/Makefile ===
SHMODULES = ncid-page.sh ncid-samba.sh ncid-speak.sh \
            ncid-mythtv.sh ncid-kpopup.sh ncid-skel.sh \
            ncid-yac.sh ncid-initmodem.sh
DIST      = ncidmodules.conf-in
FILES     = README.modules Makefile $(SHMODULES) $(DIST)

prefix    = /usr/local
prefix2   = $(prefix)

setmod    = NONE

MODULEDIR = $(prefix)/share/ncid
BIN       = $(prefix)/bin
ETC       = $(prefix2)/etc

CONFDIR   = $(ETC)/ncid

MODULES   = $(SHMODULES:.sh=)

TIVOMOD   = ncid-tivo

CONFFILE  = $(DIST:-in=)

modules: $(MODULES) $(TIVOMOD) $(CONFFILE)

install: install-etc install-modules

install-modules: $(MODULES)
	@if test ! -d $(MODULEDIR); then mkdir -p $(MODULEDIR); fi
	install -m 755 $(MODULES) $(MODULEDIR)
	@if [ "$(setmod)" != "NONE" ] ; \
		then install -m 755 $(TIVOMOD) $(MODULEDIR)/.; fi

install-etc: $(CONFFILE)
	@if test -f $(CONFDIR)/$(CONFFILE); \
		then install -m 644 $(CONFFILE) $(CONFDIR)/$(CONFFILE).new; \
		else install -m 644 $(CONFFILE) $(CONFDIR); \
	fi

clean:

clobber: clean
	rm -f $(MODULES) $(TIVOMOD) $(CONFFILE)
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: .sh -in

.sh : *.sh
	sed '/ConfigDir/s,/usr/local/etc/ncid,$(CONFDIR),' $< > $@
	chmod 755 $@

-in : *-in
	sed '/"$(setmod)"/s/#//;s,/usr/local,$(prefix),' $< > $@

=== scripts/Makefile ===
SHSCRIPT  = ncidrotate.sh
ETCCONF   = ncidrotate.conf
LOGCONF   = ncid.logrotate
FILES     = README.scripts Makefile $(SHSCRIPT) $(ETCCONF) $(LOGCONF)

prefix    = /usr/local
prefix2   = $(prefix)
prefix3   =

SHARE     = $(prefix)/share/ncid
ETC       = $(prefix2)/etc
CONFDIR   = $(ETC)/ncid
ROTATEDIR = $(ETC)/logrotate.d

ROTATE  = $(LOGCONF:.logrotate=)
SCRIPTS = $(SHSCRIPT:.sh=)

scripts: $(ROTATE) $(SCRIPTS)

install: install-etc install-scripts install-logrotate

install-scripts: $(SCRIPTS)
	@if test ! -d $(SHARE); then mkdir -p $(SHARE); fi
	install -m 755 $(SCRIPTS) $(SHARE)

install-etc: $(ETCCONF)
	@if test ! -d $(CONFDIR); then mkdir -p $(CONFDIR); fi
	@if test -f $(CONFDIR)/$(ETCCONF); \
		then install -m 644 $(ETCCONF) $(CONFDIR)/$(ETCCONF).new; \
		else install -m 644 $(ETCCONF) $(CONFDIR); \
	fi

install-logrotate: $(ROTATE)
	@if test ! -d $(ROTATEDIR); then mkdir -p $(ROTATEDIR); fi
	install -m 644 ncid $(ROTATEDIR)

clean:

clobber: clean
	rm -f $(ROTATE) $(SCRIPTS)
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: .sh .logrotate

.sh : *.sh
	sed '/ConfigDir/s,/usr/local/etc/ncid,$(CONFDIR),' $< > $@
	chmod 755 $@

.logrotate : *.logrotate
	sed '/share/s,/usr/local,$(prefix),' $< > $@

=== server/Makefile ===
PROG        = ncidd
SRC         = $(PROG).c nciddconf.c nciddalias.c nciddhangup.c poll.c
DIST        = $(PROG).conf-in
HEADER      = $(PROG).h nciddconf.h nciddalias.h nciddhangup.h poll.h
ETCFILE     = ncidd.conf ncidd.alias ncidd.blacklist
SOURCE      = $(SRC) $(DIST) $(HEADER)
FILES       = README.server Makefile $(SOURCE) $(ETCFILE)

Version := $(shell sed 's/.* //; 1q' ../VERSION)

# the prefix must end in a - (if part of a name) or a / (if part of a path)
MIPSXCOMPILE = mips-TiVo-linux-
PPCXCOMPILE  = /usr/local/tivo/bin/

# prefix and prefix2 are used on a make, install, and making a package
# # prefix3 is used on install to make a package
prefix       = /usr/local
prefix2      = $(prefix)
prefix3      =

settag       = NONE
setlock      = NONE
setname      = NONE

BASH=/bin/bash

BIN          = $(prefix)/bin
SBIN         = $(prefix)/sbin
SHARE        = $(prefix)/share
ETC          = $(prefix2)/etc
DEV          = $(prefix3)/dev
VAR          = $(prefix3)/var

CONFDIR      = $(ETC)/ncid
CONF         = $(CONFDIR)/$(PROG).conf
ALIAS        = $(CONFDIR)/ncidd.alias
BLACKLIST    = $(CONFDIR)/ncidd.blacklist

MODEMDEV     = $(DEV)/modem

LOGDIR       = $(VAR)/log
LOGFILE      = $(LOGDIR)/$(PROG).log
CALLLOG      = $(LOGDIR)/cidcall.log
DATALOG      = $(LOGDIR)/ciddata.log

RUNDIR       = $(VAR)/run
PIDFILE      = $(RUNDIR)/$(PROG).pid

LOCKDIR      = $(VAR)/lock/lockdev
LOCKFILE     = $(LOCKDIR)/LCK..

SITE         = $(DIST:-in=)

OBJECT       = $(SRC:.c=.o)

DEFINES      = -DCIDCONF=\"$(CONF)\" \
               -DCIDALIAS=\"$(ALIAS)\" \
			   -DBLACKLIST=\"$(BLACKLIST)\" \
               -DCIDLOG=\"$(CALLLOG)\" \
               -DTTYPORT=\"$(MODEMDEV)\" \
               -DDATALOG=\"$(DATALOG)\" \
               -DLOGFILE=\"$(LOGFILE)\" \
               -DPIDFILE=\"$(PIDFILE)\" \
               -DLOCKFILE=\"$(LOCKFILE)\"

# local additions to CFLAGS
MFLAGS       = -W -Wmissing-declarations

CFLAGS       = -O2 -I. -I.. $(DEFINES) $(MFLAGS) $(EXTRA_CFLAGS)

STRIP        = -s
LDFLAGS      = $(STRIP)
LDLIBS       =

usage:
	@echo "to build a TiVo ppc binary for /var/hack: make tivo-s1"
	@echo "to build a TiVo mips binary for /var/hack: make tivo-s2"
	@echo "to build a TiVo mips binary for /usr/local: make tivo-mips"
	@echo "to build a Win/cygwin binary: make cygwin"
	@echo "to build a Linux, BSD, or Mac binary: make local"
	@echo "to install in /usr/local: make install"

tivo-s1:
	$(MAKE) tivo-ppc prefix=/var/hack

tivo-ppc:
	$(MAKE) server \
			CC=$(PPCXCOMPILE)gcc \
			MFLAGS="-DTIVO_S1 -D__need_timeval" \
			LD=$(PPCXCOMPILE)ld \
			RANLIB=$(PPCXCOMPILE)ranlib \
			setname="TiVo requires CLOCAL" \
			settag="TiVo PPC Modem Port" \
			setlock="TiVo Modem Lockfile"
	touch tivo-ppc

tivo-s2:
	$(MAKE) tivo-mips prefix=/var/hack \

tivo-mips:
	$(MAKE) server \
			CC=$(MIPSXCOMPILE)gcc \
			MFLAGS="-std=gnu99" \
			LD=$(MIPSXCOMPILE)ld \
			RANLIB=$(MIPSXCOMPILE)ranlib \
			setname="TiVo requires CLOCAL" \
			settag="TiVo MIPS Modem Port" \
			setlock="TiVo Modem Lockfile"
	touch tivo-mips

cygwin:
	$(MAKE) server prefix=/usr prefix2= \
			CFLAGS="$(CFLAGS) -IC:/WpdPack/Include" \
			LDLIBS="$(LDLIBS) -LC:/WpdPack/Lib -lwpcap"

local:
	$(MAKE) server

server: $(PROG) site

site: $(SITE)

$(PROG): $(SRC) $(HEADER) ../version.h
	$(CC) $(CFLAGS) -o $@ $(SRC)

../version.h: ../version.h-in
	sed "s/XXX/$(Version)/" $? > $@

install: $(PROG) dirs install-etc
	install -m 755 $(PROG) $(SBIN)

install-etc: site
	@if test -f $(CONF); \
		then install -m 644 $(PROG).conf $(CONF).new; \
		else install -m 644 $(PROG).conf $(CONFDIR); \
	fi
	@if test -f $(ALIAS); \
		then install -m 644 $(PROG).alias $(ALIAS).new; \
		else install -m 644 $(PROG).alias $(CONFDIR); \
	fi
	@if test -f $(BLACKLIST); \
		then install -m 644 $(PROG).blacklist $(BLACKLIST).new; \
		else install -m 644 $(PROG).blacklist $(CONFDIR); \
	fi

dirs:
	@if ! test -d $(SBIN); then mkdir -p $(SBIN); fi
	@if ! test -d $(CONFDIR); then mkdir -p $(CONFDIR); fi

clean:
	rm -f *.o *.a

clobber: clean
	rm -f $(PROG) $(PROG).ppc-tivo $(PROG).mips-tivo tivo-ppc tivo-mips
	rm -f $(PROG).ppc-mac $(PROG).i386-mac
	rm -f $(SITE)
	rm -f a.out *.log *.zip *.tar.gz *.tgz

distclean: clobber

files:	$(FILES)

.SUFFIXES: -in

-in : *-in
	sed '/share/s,/usr/local,$(prefix),;/$(settag)/s/# set/set/;/$(setname)/s/# set/set/;/$(setlock)/s/# set/set/' $< > $@

=== test/Makefile ===
# Makefile to clean created test files and archive files

default:

clean:
	rm -f T-* vmodem0

clobber: clean
	rm -f *.zip *.tar.gz *.tgz

distclean: clobber

=== debian/changelog ===
ncid (0.83-0ubuntu1) 11.04; urgency=low

  * See NCID CHANGES file
  * removed ncid-tivo.1 from rules
  * added ncid-skel to rules

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Tue,  2 Aug 2011 23:27:00:00 -0400

ncid (0.82.1-0ubuntu1) 11.04; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Fri,  6 Jun 2011 13:07:00:00 -0400

ncid (0.81-0ubuntu1) 10.04; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Sat,  26 Feb 2011 10:41:00:00 -0400

ncid (0.80-0ubuntu1) 10.04; urgency=low

  * See NCID CHANGES file
  * changed Requires: and added Recommends: for ncid-client in control

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Sun,  10 Oct 2010 23:18:00:00 -0400

ncid (0.79-0ubuntu1) 10.04; urgency=low

  * See NCID CHANGES file
  * added ncid2ncid.init file and ncid2ncid.init to rules

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Thu,  1 Jul 2010 20:26:00:00 -0400

ncid (0.78-0ubuntu1) 10.04; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Fri,  14 May 2010 13:16:00:00 -0400

ncid (0.77-0ubuntu1) Karmic Koala; urgency=low

  * See NCID CHANGES file
  * removed postrm-kpopup and prerm-kpopup
  * removed ncid-kpopup.init file, and ncid-kpopup.init from rules
  * removed prerm-ncid-kpopup file, and postrm-ncid-kpopup from rules
  * added ncid-initmodem.init files, and ncid-initmodem.init to rules
  * added ncid-initmodem to postrm-client and prerm-client

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Thu,  25 Mar 2010 23:20:00 -0400

ncid (0.76-0ubuntu1) Karmic Koala; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Sat,  23 Jan 2010 21:41:00 -0400

ncid (0.75-0ubuntu1) Jaunty Jackalope; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Sat,  12 Sep 2009 18:01:00 -0400

ncid (0.74-0ubuntu1) Jaunty Jackalope; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Fri,  19 Jun 2009 16:20:00 -0400

ncid (0.73-0ubuntu1) Hardy Heron; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Tue,  3 Feb 2009 18:31:00 -0400

ncid (0.72-0ubuntu1) Hardy Heron; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Thu,  20 Nov 2008 22:56:14 -0400

ncid (0.71-0ubuntu1) Hardy Heron; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Mon,  2 Jun 2008 19:04:23 -0400

ncid (0.70-0ubuntu1) Feisty; urgency=low

  * See NCID CHANGES file

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Thu,  14 Feb 2008 13:33:23 -0400

ncid (0.69-0ubuntu1) Feisty; urgency=low

  * Initial Release.

 -- John L. Chmielewski <jlc@users.sourceforge.net>  Tue,  9 Oct 2007 11:37:23 -0400

=== debian/control ===
Source: ncid
Section: net
Priority: optional
Maintainer: John L. Chmielewski <jlc@users.sourceforge.net>
Build-Depends: libpcap0.8-dev
Standards-Version: 3.7.2

Package: ncid
Architecture: i386
Depends: ${shlibs:Depends}, libpcap0.8, perl
Description: NCID (Network Caller ID) server, client, and gateways
 NCID is Caller ID (CID) distributed over a network to a variety of
 devices and computers. NCID includes a server, gateways, a client,
 and client output modules.
 .
 The NCID server obtains the Caller ID information from a serial device,
 like a modem, and from VOIP and YAC gateways.
 .
 This package contains the server and gateways.  The client is in the
 ncid-client package.

Package: ncid-client
Architecture: all
Depends: tcl8.4, tk8.4
Recommends: mailx
Description: NCID (Network Caller ID) client and base output modules
 The ncid-client obtains the Caller ID from the ncid-server and normally
 displays it in a GUI window.  It can also display the Called ID in a
 terminal window or, using a output module, format the output and send it
 to another program.
 .
 This package contains the NCID client with the page, yac, and skel
 output modules.

Package: ncid-kpopup
Architecture: all
Depends: ncid-speak, kdelibs4c2a, kmix, aumix
Description: NCID (Network Caller ID) client KDE popup module
 The NCID kpopup module displays caller ID information in a KDE popup window
 and optionally speaks the number via voice synthesis.

Package: ncid-mythtv
Architecture: all
Depends: ncid-client, mythtv-frontend
Description: NCID (Network Caller ID) MythTV client module
 The NCID MythTV module displays caller ID information using mythtvosd.

Package: ncid-samba
Architecture: all
Depends: ncid-client, samba
Description: NCID (Network Caller ID) samba client module
 The NCID samba module sends caller ID information to a windows machine
 as a popup.  This will not work if the messenger service is disabled.

Package: ncid-speak
Architecture: all
Depends: ncid-client, festival
Description: NCID (Network Caller ID) speak client module
 The NCID speak module announces Caller Id information verbally, using
 the Festival text-to-speech voice synthesis system.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules file - for GNU Hello.
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified
#
# Modified by John L. Chmielewski to package ncid
# Last Modified Fri Sep 2, 2011

package = ncid
prog    = ncidd

pkg = client mythtv kpopup samba speak

docdir  = usr/share/doc/$(package)

build:
	$(checkdir)
	$(MAKE) ubuntu
	touch build

clean:
	$(checkdir)
	rm -f build
	-$(MAKE) -i distclean
	rm -rf *~ debian/tmp* debian/*~ debian/files* debian/substvars

binary-indep:   checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:    checkroot build
	$(checkdir)
	rm -rf debian/tmp*
	install -d debian/tmp/DEBIAN debian/tmp/$(docdir) \
                   debian/tmp-ncid/DEBIAN debian/tmp-ncid/$(docdir)
	for i in $(pkg); do \
		install -d debian/tmp-$$i/DEBIAN \
                           debian/tmp-$$i/usr/share/doc/$(package)-$$i; \
        done
	$(MAKE) \
		prefix=$$(pwd)/debian/tmp/usr \
		prefix2=$$(pwd)/debian/tmp \
		prefix3=$$(pwd)/debian/tmp \
		install install-ubuntu

        # NCID server and gateways and support utilities
	install -m 755 debian/postinst debian/prerm debian/postrm \
                       debian/tmp-ncid/DEBIAN
	cp -a debian/tmp/* debian/tmp-ncid
	rm -f debian/tmp-ncid/etc/init.d/ncid-* \
	      debian/tmp-ncid/etc/ncid/ncid.* \
          debian/tmp-ncid/etc/ncid/ncidmodules.conf \
	      debian/tmp-ncid/usr/bin/ncid \
	      debian/tmp-ncid/usr/share/doc/ncid/README.modules \
	      debian/tmp-ncid/usr/share/man/man1/ncid.1 \
          debian/tmp-ncid/usr/share/man/man1/ncidmodules.1 \
	      debian/tmp-ncid/usr/share/man/man5/ncid.conf.5 \
          debian/tmp-ncid/usr/share/man/man5/ncidmodules.conf.5 \
          debian/tmp-ncid/usr/share/ncid/ncid-*
	rm -fr debian/tmp-ncid/usr/share/pixmaps
	install -m 644 debian/changelog debian/tmp-ncid/$(docdir)/changelog.Debian
	cp -a README VERSION doc debian/README.Debian \
          server/README.server cidgate/README.Gateways \
          scripts/README.scripts tools/README.tools \
                   debian/tmp-ncid/$(docdir)
	rm -f debian/tmp-ncid/$(docdir)/doc/CHANGES
	dpkg-shlibdeps debian/tmp-ncid/usr/sbin/ncidd \
                   debian/tmp-ncid/usr/sbin/ncid2ncid \
                   debian/tmp-ncid/usr/sbin/sip2ncid

        # NCID client and base output modules
	install -m 755 debian/postinst debian/tmp-client/DEBIAN
	install -m 755 debian/prerm-client debian/tmp-client/DEBIAN/prerm
	install -m 755 debian/postrm-client debian/tmp-client/DEBIAN/postrm
	cd debian/tmp-client; mkdir -p etc/init.d etc/ncid usr/bin \
       usr/share/ncid usr/share/man/man1 usr/share/man/man5
	mkdir -p debian/tmp-client/usr/share/pixmaps/ncid
	install -m 755 client/ncid debian/tmp-client/usr/bin
	install -m 644 client/ncid.gif debian/tmp-client/usr/share/pixmaps/ncid
	install -m 644 client/ncid.conf modules/ncidmodules.conf \
                   debian/tmp-client/etc/ncid
	cd modules; install -m 755 ncid-initmodem ncid-page ncid-skel ncid-yac \
                               ../debian/tmp-client/usr/share/ncid
	install -m 644 README VERSION client/README.client modules/README.modules \
          debian/tmp-client/usr/share/doc/ncid-client/.
	cd debian; install -m 755 ncid-initmodem ncid-page ncid-yac \
                              ../debian/tmp-client/etc/init.d
	install -m 644 man/ncid.1 man/ncidmodules.1 man/ncid-initmodem.1 \
                   man/ncid-page.1 man/ncid-skel.1 \
                   man/ncid-yac.1 debian/tmp-client/usr/share/man/man1
	install -m 644 man/ncid.conf.5 man/ncidmodules.conf.5 \
                   debian/tmp-client/usr/share/man/man5

        # NCID client KDE popup module
	install -m 755 debian/postinst debian/tmp-kpopup/DEBIAN
	cd debian/tmp-kpopup; mkdir -p usr/share/ncid \
                   usr/share/ncid usr/share/man/man1 usr/share/man/man1
	install -m 644 VERSION modules/README.modules \
                   debian/tmp-kpopup/usr/share/doc/ncid-kpopup
	install -m 755 modules/ncid-kpopup debian/tmp-kpopup/usr/share/ncid/.
	install -m 644 man/ncid-kpopup.1 debian/tmp-kpopup/usr/share/man/man1

        # NCID client MythTV module
	install -m 755 debian/postinst debian/tmp-mythtv/DEBIAN
	install -m 755 debian/prerm-mythtv debian/tmp-mythtv/DEBIAN/prerm
	install -m 755 debian/postrm-mythtv debian/tmp-mythtv/DEBIAN/postrm
	cd debian/tmp-mythtv; mkdir -p etc/init.d usr/share/ncid \
                   usr/share/ncid usr/share/man/man1 usr/share/man/man1
	install -m 644 VERSION modules/README.modules \
                   debian/tmp-mythtv/usr/share/doc/ncid-mythtv
	install -m 755 modules/ncid-mythtv debian/tmp-mythtv/usr/share/ncid/.
	install -m 755 debian/ncid-mythtv debian/tmp-mythtv/etc/init.d/.
	install -m 644 man/ncid-mythtv.1 debian/tmp-mythtv/usr/share/man/man1

        # NCID client samba module
	install -m 755 debian/postinst debian/tmp-samba/DEBIAN
	install -m 755 debian/prerm-samba debian/tmp-samba/DEBIAN/prerm
	install -m 755 debian/postrm-samba debian/tmp-samba/DEBIAN/postrm
	cd debian/tmp-samba; mkdir -p etc/init.d usr/share/ncid \
                   usr/share/ncid usr/share/man/man1 usr/share/man/man1
	install -m 644 VERSION modules/README.modules \
                   debian/tmp-samba/usr/share/doc/ncid-samba
	install -m 755 modules/ncid-samba debian/tmp-samba/usr/share/ncid/.
	install -m 755 debian/ncid-samba debian/tmp-samba/etc/init.d/.
	install -m 644 man/ncid-samba.1 debian/tmp-samba/usr/share/man/man1

        # NCID client speak module
	install -m 755 debian/postinst debian/tmp-speak/DEBIAN
	install -m 755 debian/prerm-speak debian/tmp-speak/DEBIAN/prerm
	install -m 755 debian/postrm-speak debian/tmp-speak/DEBIAN/postrm
	cd debian/tmp-speak; mkdir -p etc/init.d usr/share/ncid \
                   usr/share/ncid usr/share/man/man1 usr/share/man/man1
	install -m 644 VERSION modules/README.modules \
                   debian/tmp-speak/usr/share/doc/ncid-speak
	install -m 755 modules/ncid-speak debian/tmp-speak/usr/share/ncid/.
	install -m 755 debian/ncid-speak debian/tmp-speak/etc/init.d/.
	install -m 644 man/ncid-speak.1 debian/tmp-speak/usr/share/man/man1

        # cleanup and build packages
	gzip -r9 debian/tmp-ncid/usr/share/man debian/tmp-client/usr/share/man
	for i in $(package) $(pkg); do \
        find debian/tmp-$$i -name \*CVS -print | xargs rm -fr; \
        chown -R root:root debian/tmp-$$i; \
        chmod -R u+w,go=rX debian/tmp-$$i; \
        if [ $$i = "ncid" ] ; then \
            dpkg-gencontrol -isp -Pdebian/tmp-$$i -pncid; else  \
            dpkg-gencontrol -isp -Pdebian/tmp-$$i -pncid-$$i; fi; \
        dpkg --build debian/tmp-$$i ..; \
        done

define checkdir
	test -f server/$(prog).c -a -f debian/rules
endef

binary: binary-indep binary-arch

checkroot:
	$(checkdir)
	test $$(id -u) = 0

.PHONY: binary binary-arch binary-indep clean checkroot
